## wildmidi 0.4.6

=== CMakeLists.txt ===
# Project setup
CMAKE_MINIMUM_REQUIRED(VERSION 3.4...3.5)
PROJECT(wildmidi LANGUAGES C VERSION 0.4.6)

# WildMIDI Version
SET(WILDMIDI_VERSION ${PROJECT_VERSION})

# Lib Versions
SET(SOVERSION 2)
SET(VERSION 2.1.0)

# Find Macros
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

INCLUDE(CMakeDependentOption)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckCSourceCompiles)
INCLUDE(CheckIncludeFile)
INCLUDE(GNUInstallDirs)
INCLUDE(TestBigEndian)

# Set our options
OPTION(BUILD_SHARED_LIBS "Build a dynamic wildmidi library" ON)
OPTION(WANT_PLAYER "Build WildMIDI player in addition to the libraries" ON)
OPTION(WANT_STATIC "Build static library in addition to dynamic library" OFF)
CMAKE_DEPENDENT_OPTION(WANT_PLAYERSTATIC "Build a statically linked WildMIDI player" ON "WANT_STATIC;WANT_PLAYER" OFF)

# Player options
IF (CMAKE_SYSTEM_NAME MATCHES ".*Linux")
    SET(ALSA_DEFAULT ON)
ELSE()
    SET(ALSA_DEFAULT OFF)
ENDIF()
IF (CMAKE_SYSTEM_NAME MATCHES "DragonFly.*|kFreeBSD.*|FreeBSD")
    SET(OSS_DEFAULT ON)
ELSE()
    SET(OSS_DEFAULT OFF)
ENDIF()
IF (CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
    SET(SNDIO_DEFAULT ON)
    SET(SYS_OPENBSD TRUE)
    SET(USE_RPATH_DEFAULT  ON)
ELSE()
    SET(SNDIO_DEFAULT OFF)
    SET(SYS_OPENBSD FALSE)
    SET(USE_RPATH_DEFAULT OFF)
ENDIF()
IF(CMAKE_SYSTEM_NAME MATCHES "kNetBSD.*|NetBSD.*")
    SET(SYS_NETBSD TRUE)
ELSE()
    SET(SYS_NETBSD FALSE)
ENDIF()

OPTION(WANT_RPATH "Use RPATH when linking" ${USE_RPATH_DEFAULT})

CMAKE_DEPENDENT_OPTION(WANT_AMIGA_AHI "Include Amiga AHI support" ON "AMIGA" OFF)
CMAKE_DEPENDENT_OPTION(WANT_ALSA "Include ALSA (Advanced Linux Sound Architecture) support" ${ALSA_DEFAULT} "UNIX" OFF)
CMAKE_DEPENDENT_OPTION(WANT_COREAUDIO "Include macOS CoreAudio support" ON "APPLE" OFF)
CMAKE_DEPENDENT_OPTION(WANT_DOSSB "Include DOS SoundBlaster support" ON "DJGPP" OFF)
CMAKE_DEPENDENT_OPTION(WANT_OS2DART "Include OS/2 DART support" ON "OS2" OFF)
CMAKE_DEPENDENT_OPTION(WANT_NETBSD "Include NetBSD audio support" ON "SYS_NETBSD" OFF)
CMAKE_DEPENDENT_OPTION(WANT_OSS "Include OSS (Open Sound System) support" ${OSS_DEFAULT} "UNIX" OFF)
CMAKE_DEPENDENT_OPTION(WANT_SNDIO "Include OpenBSD sndio support" ${SNDIO_DEFAULT} "UNIX" OFF)
CMAKE_DEPENDENT_OPTION(WANT_WINMM "Include Windows WinMM audio support" ON "WIN32 OR CYGWIN" OFF)
OPTION(WANT_OPENAL "Include OpenAL (Cross Platform) support" OFF)

OPTION(WANT_DEVTEST "Build WildMIDI DevTest file to check files" OFF)

CMAKE_DEPENDENT_OPTION(WANT_MP_BUILD "Build with Multiple Processes (/MP)" OFF "WIN32;MSVC" OFF)
CMAKE_DEPENDENT_OPTION(WANT_OSX_DEPLOYMENT "OSX Deployment" OFF "APPLE" OFF)

IF (UNIX AND NOT APPLE AND NOT RISCOS)
    SET(WILDMIDI_CFG "/etc/wildmidi/wildmidi.cfg" CACHE STRING "default config location")
ELSE ()
    SET(WILDMIDI_CFG "wildmidi.cfg" CACHE STRING "default config location")
ENDIF()

IF ((NOT BUILD_SHARED_LIBS) AND (NOT WANT_STATIC))
    MESSAGE(FATAL_ERROR "Neither dynamic nor static library build is selected.")
ENDIF()

### See:  http://www.cmake.org/Wiki/CMake_RPATH_handling
IF (WANT_RPATH)
    # use, i.e. don't skip the full RPATH for the build tree
    SET(CMAKE_SKIP_BUILD_RPATH FALSE)

    # when building, don't use the install RPATH already
    # (but later on when installing)
    SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

    # add the automatically determined parts of the RPATH
    # which point to directories outside the build tree to the install RPATH
    SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

    # the RPATH to be used when installing, but only if it's not a system directory
    LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES ${CMAKE_INSTALL_FULL_LIBDIR} isSystemDir)
    IF ("${isSystemDir}" STREQUAL "-1")
        SET(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
    ENDIF()
ENDIF()

# Platform specific defines
IF (WIN32)
    ADD_DEFINITIONS(
        -DWIN32_LEAN_AND_MEAN
        -DNOMINMAX
        -D_CRT_SECURE_NO_WARNINGS
    )
ELSEIF (UNIX)
    # allow 'large' files in 32 bit builds
    ADD_DEFINITIONS(
        -D_LARGEFILE_SOURCE
        -D_FILE_OFFSET_BITS=64
        -D_LARGE_FILES
    )
ENDIF()

# Compiler specific settings
IF (CMAKE_COMPILER_IS_GNUCC OR (CMAKE_C_COMPILER_ID MATCHES "Clang"))
    IF (NOT MSVC) # exclude clang-cl
        ADD_DEFINITIONS(
            -Wall -W
            -fno-common
        )
    ENDIF()

    IF (NOT WIN32 AND NOT CYGWIN)
        SET(OLD_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
        SET(CMAKE_REQUIRED_FLAGS "${OLD_REQUIRED_FLAGS} -Werror")
        CHECK_C_SOURCE_COMPILES("int foo(void) __attribute__((visibility(\"default\")));
                                 int main(void) {return 0;}" HAVE_VISIBILITY_DEFAULT)
        IF (HAVE_VISIBILITY_DEFAULT)
            CHECK_C_COMPILER_FLAG(-fvisibility=hidden HAVE_VISIBILITY_HIDDEN)
        ENDIF()
        SET(CMAKE_REQUIRED_FLAGS "${OLD_REQUIRED_FLAGS}")
    ENDIF()

    IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
        ADD_DEFINITIONS(-ggdb3 -O0)
    ELSEIF (CMAKE_BUILD_TYPE STREQUAL "Release")
        ADD_DEFINITIONS(-O3)
    ENDIF()
ENDIF()

IF (CMAKE_C_COMPILER_ID MATCHES "SunPro")
    SET(OLD_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
    SET(CMAKE_REQUIRED_FLAGS "${OLD_REQUIRED_FLAGS} -xldscope=hidden")
    # __SUNPRO_C >= 0x590
    #   CHECK_C_SOURCE_COMPILES("int foo(void) __attribute__((visibility(\"default\")));
    #                            int main(void) {return 0;}" HAVE_VISIBILITY_DEFAULT)
    # __SUNPRO_C >= 0x550
    CHECK_C_SOURCE_COMPILES("__global int foo(void);
                             int main(void) {return 0;}" HAVE_LDSCOPE_GLOBAL)
    IF (HAVE_LDSCOPE_GLOBAL)# OR HAVE_VISIBILITY_DEFAULT
        SET(HAVE_LDSCOPE_HIDDEN 1)
    ENDIF()
    SET(CMAKE_REQUIRED_FLAGS "${OLD_REQUIRED_FLAGS}")
ENDIF()

CHECK_C_SOURCE_COMPILES("int main(void) {__builtin_expect(0,0); return 0;}" HAVE___BUILTIN_EXPECT)

CHECK_C_SOURCE_COMPILES("static inline int static_foo() {return 0;}
                         int main(void) {return 0;}" HAVE_C_INLINE)
CHECK_C_SOURCE_COMPILES("static __inline__ int static_foo() {return 0;}
                         int main(void) {return 0;}" HAVE_C___INLINE__)
CHECK_C_SOURCE_COMPILES("static __inline int static_foo() {return 0;}
                         int main(void) {return 0;}" HAVE_C___INLINE)

# we must not have any unresolved symbols:
if (APPLE)
    SET(EXTRA_LDFLAGS "-Wl,-undefined,error")
ELSEIF(SYS_OPENBSD)
    SET(EXTRA_LDFLAGS "")
ELSE()
    SET(OLD_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
    SET(CMAKE_REQUIRED_FLAGS "${OLD_REQUIRED_FLAGS} -Wl,--no-undefined")
    CHECK_C_COMPILER_FLAG("" HAVE_NO_UNDEFINED)
    SET(CMAKE_REQUIRED_FLAGS "${OLD_REQUIRED_FLAGS}")
    IF (HAVE_NO_UNDEFINED)
        SET(EXTRA_LDFLAGS "-Wl,--no-undefined")
    ELSE()
        SET(EXTRA_LDFLAGS "")
    ENDIF()
ENDIF()

CHECK_INCLUDE_FILE(stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)

TEST_BIG_ENDIAN(WORDS_BIGENDIAN)

# UNIX-like environments
IF (UNIX AND NOT APPLE)
    # find our math lib
    FIND_LIBRARY(M_LIBRARY m)
    MESSAGE(STATUS "M_LIBRARY: ${M_LIBRARY}")
    IF (NOT M_LIBRARY)
        SET(M_LIBRARY "")
        SET(PKG_PRIVATELIBS "")
    ELSE()
        SET(PKG_PRIVATELIBS "-lm")
    ENDIF()
ENDIF()

# ######### General setup ##########
INCLUDE_DIRECTORIES(BEFORE "${PROJECT_SOURCE_DIR}/include" "${PROJECT_BINARY_DIR}/include")
IF (NOT HAVE_STDINT_H) # AND NOT HAVE_INTTYPES_H
    INCLUDE_DIRECTORIES(BEFORE "${PROJECT_SOURCE_DIR}/include/stdint")
ENDIF()

IF (AMIGA OR AROS)
    SET(WILDMIDI_AMIGA 1)
ENDIF()

IF (APPLE)
    SET(APP_BUNDLE_NAME "${CMAKE_PROJECT_NAME}.app")
    SET(APP_BUNDLE_DIR "${wildmidi_BINARY_DIR}/${APP_BUNDLE_NAME}")
    IF (WANT_OSX_DEPLOYMENT)
        SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    ENDIF()
ENDIF()

IF (APPLE)
    SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${APP_BUNDLE_DIR}/Contents/MacOS")
ENDIF()

IF(WANT_PLAYER OR WANT_PLAYERSTATIC)
    SET(ENABLED_OUTPUT "")

    IF (WANT_AMIGA_AHI)
        SET(AUDIODRV_AHI 1)
        STRING(APPEND ENABLED_OUTPUT " ahi")
    ENDIF()

    IF (WANT_ALSA)
        FIND_PACKAGE(ALSA REQUIRED)
        SET(AUDIODRV_ALSA 1)
        LIST(APPEND AUDIO_LIBRARY ${ALSA_LIBRARIES})
        STRING(APPEND ENABLED_OUTPUT " alsa")
    ENDIF()

    IF (WANT_COREAUDIO)
        SET(AUDIODRV_COREAUDIO 1)
        LIST(APPEND AUDIO_LIBRARY -Wl,-framework,AudioToolbox)
        LIST(APPEND AUDIO_LIBRARY -Wl,-framework,AudioUnit)
        LIST(APPEND AUDIO_LIBRARY -Wl,-framework,CoreServices)
        STRING(APPEND ENABLED_OUTPUT " coreaudio")
    ENDIF()

    IF (WANT_DOSSB)
        SET(AUDIODRV_DOSSB 1)
        STRING(APPEND ENABLED_OUTPUT " dossb")
    ENDIF()

    IF (WANT_OPENAL)
        FIND_PACKAGE(OpenAL REQUIRED)
        SET(AUDIODRV_OPENAL 1)
        LIST(APPEND AUDIO_LIBRARY ${OPENAL_LIBRARY})
        STRING(APPEND ENABLED_OUTPUT " openal")
    ENDIF()

    IF (WANT_OS2DART)
        SET(AUDIODRV_OS2DART 1)
        LIST(APPEND AUDIO_LIBRARY mmpm2)
        STRING(APPEND ENABLED_OUTPUT " dart")
    ENDIF()

    IF (WANT_OSS)
        FIND_PACKAGE(OSS REQUIRED)
        SET(AUDIODRV_OSS 1)
        IF(OSS_LIBRARIES)
           LIST(APPEND AUDIO_LIBRARY ${OSS_LIBRARIES})
        ENDIF()
        STRING(APPEND ENABLED_OUTPUT " oss")
    ENDIF()

    IF (WANT_NETBSD)
        FIND_PACKAGE(AudioIO REQUIRED)
        SET(AUDIODRV_NETBSD 1)
        STRING(APPEND ENABLED_OUTPUT " netbsd")
    ENDIF()

    IF (WANT_SNDIO)
        FIND_PACKAGE(SNDIO REQUIRED)
        SET(AUDIODRV_SNDIO 1)
        LIST(APPEND AUDIO_LIBRARY ${SNDIO_LIBRARIES})
        STRING(APPEND ENABLED_OUTPUT " sndio")
    ENDIF()

    IF (WANT_WINMM)
        SET(AUDIODRV_WINMM 1)
        LIST(APPEND AUDIO_LIBRARY winmm)
        STRING(APPEND ENABLED_OUTPUT " winmm")
    ENDIF()

    # WAV file output as an audio output backend is always enabled
    STRING(APPEND ENABLED_OUTPUT " wave")

    STRING(STRIP ${ENABLED_OUTPUT} ENABLED_OUTPUT)
    MESSAGE(STATUS "Enabled audio output backends: ${ENABLED_OUTPUT}")
ENDIF()

# Setup up our config file
CONFIGURE_FILE("${PROJECT_SOURCE_DIR}/include/config.h.cmake" "${PROJECT_BINARY_DIR}/include/config.h")

ADD_SUBDIRECTORY(src)

=== amiga/Makefile ===
# GNU Makefile to build for AmigaOS variants using gcc
#
# make aros     : build for i386-aros
# make morphos  : build for ppc-morphos
# make amigaos  : build for m68k-amigaos
# make amigaos4 : build for ppc-amigaos4

# Set to 1 for debug build
DEBUG = 0

# The tools
ifeq ($(CROSS),)
CC=gcc
AS=as
AR=ar
RANLIB=ranlib
else
CC=$(CROSS)-gcc
AS=$(CROSS)-as
AR=$(CROSS)-ar
RANLIB=$(CROSS)-ranlib
endif

INCLUDE = -I. -I../include
CFLAGS = $(INCLUDE) -Wall -W -fno-common
ARFLAGS = cr
LD = $(CC)
LDFLAGS = -L. -lWildMidi

ifeq ($(DEBUG),1)
CFLAGS += -g
else
CFLAGS += -O2
endif

ifeq ($(AROS),1)
include gcc_aros.cfg
endif
ifeq ($(MORPHOS),1)
include gcc_morphos.cfg
endif
ifeq ($(AOS3),1)
include gcc_aos3.cfg
endif
ifeq ($(AOS4),1)
include gcc_aos4.cfg
endif

# Build rules
%.o: %.c
	$(CC) -c $(CFLAGS) -o $@ $<
%.o: ../src/%.c
	$(CC) -c $(CFLAGS) -o $@ $<
%.o: ../src/player/%.c
	$(CC) -c $(CFLAGS) -o $@ $<

# Objects
LIB_OBJ= wm_error.o file_io.o lock.o wildmidi_lib.o reverb.o gus_pat.o f_xmidi.o f_mus.o f_hmp.o f_midi.o f_hmi.o mus2mid.o xmi2mid.o internal_midi.o patches.o sample.o
PLAYER_OBJ= amiga.o wm_tty.o msleep.o getopt_long.o out_none.o out_wave.o out_ahi.o wildmidi.o

# Build targets
.PHONY: clean distclean
all: libWildMidi.a wildmidi

libWildMidi.a: $(LIB_OBJ)
	$(AR) $(ARFLAGS) $@ $^
	$(RANLIB) $@

wildmidi: libWildMidi.a $(PLAYER_OBJ)
	$(LD) -o $@ $(PLAYER_OBJ) $(LDFLAGS)

aros:
	@echo Building for i386-aros
	$(MAKE) AROS=1
morphos:
	@echo Building for ppc-morphos
	$(MAKE) MORPHOS=1
amigaos:
	@echo Building for m68k-amigaos
	$(MAKE) AOS3=1
amigaos4:
	@echo Building for ppc-amigaos4
	$(MAKE) AOS4=1

clean:
	rm -rf $(LIB_OBJ) $(PLAYER_OBJ)
distclean: clean
	rm -rf libWildMidi.a WildMidi.lib wildmidi

=== djgpp/Makefile ===
#------------------------------------------------------------------------------#
# Makefile for building WildMidi library and player for DOS.
# You will need a DJGPP build environment and GNU make to do it painlessly.
# To build natively on DOS, you need long file names support (e.g. doslfn.)
#------------------------------------------------------------------------------#

# Set to 1 for debug build
DEBUG = 0

# DXE3 version of the library requires DJGPP-2.05 or newer.
# Set to 0 if dont want to build / use a DXE3 version of the library.
USE_DXE = 1

# The tools
ifeq ($(CROSS),)
CC=gcc
AS=as
AR=ar
RANLIB=ranlib
else
CC=$(CROSS)-gcc
AS=$(CROSS)-as
AR=$(CROSS)-ar
RANLIB=$(CROSS)-ranlib
endif
DXE3GEN=dxe3gen

INCLUDE = -I. -I../include/stdint -I../include
CFLAGS = $(INCLUDE) -Wall -W -fno-common
ARFLAGS = cr

LD = $(CC)
ifneq ($(USE_DXE),1)
WM_LINK = WildMidi
else
WM_LINK = WildMidi_dxe
endif
LDFLAGS = -L. -l$(WM_LINK)

# build for pentium and newer (comment out if not wanted)
CFLAGS += -march=i586
ifeq ($(DEBUG),1)
CFLAGS += -g
else
CFLAGS += -O2 -fomit-frame-pointer -ffast-math
endif

# Build rules
%.o: %.c
	$(CC) -c $(CFLAGS) -o $@ $<
%.o: ../src/%.c
	$(CC) -c $(CFLAGS) -o $@ $<
%.o: ../src/player/%.c
	$(CC) -c $(CFLAGS) -o $@ $<
%.o: ../src/player/dos/%.c
	$(CC) -c $(CFLAGS) -o $@ $<


# Objects
LIB_OBJ= wm_error.o file_io.o lock.o wildmidi_lib.o reverb.o gus_pat.o f_xmidi.o f_mus.o f_hmp.o f_midi.o f_hmi.o mus2mid.o xmi2mid.o internal_midi.o patches.o sample.o
PLAYER_OBJ= wm_tty.o msleep.o getopt_long.o out_none.o dosirq.o dosdma.o dossb.o out_dossb.o out_wave.o wildmidi.o

# Build targets
TARGETS = libWildMidi.a wildmidi.exe libWildMidi_dxe.a wildmidi.dxe

.PHONY: clean distclean
all: $(TARGETS)

libWildMidi.a: $(LIB_OBJ)
	$(AR) $(ARFLAGS) $@ $^
	$(RANLIB) $@

libWildMidi_dxe.a: wildmidi.dxe
wildmidi.dxe: $(LIB_OBJ)
	-$(DXE3GEN) -Y libWildMidi_dxe.a -o $@ -E _WildMidi_ -U  $^

wildmidi.exe: lib$(WM_LINK).a $(PLAYER_OBJ)
	$(LD) -o $@ $(PLAYER_OBJ) $(LDFLAGS)

clean:
	rm -rf $(LIB_OBJ) $(PLAYER_OBJ)
distclean: clean
	rm -rf $(TARGETS)

=== macosx/Makefile ===
# Makefile to build WildMidi library and player for Mac OS X.

# Set to 1 for debug build
DEBUG = 0

# The tools
ifeq ($(CROSS),)
CC=gcc
AS=as
AR=ar
RANLIB=ranlib
LIPO=lipo
else
CC=$(CROSS)-gcc
AS=$(CROSS)-as
AR=$(CROSS)-ar
RANLIB=$(CROSS)-ranlib
LIPO=$(CROSS)-lipo
endif
LD = $(CC)

DYLIB_MAJ=2
DYLIB_MID=1
DYLIB_MIN=0

LIBNAME=WildMidi
LIBSTATIC=lib$(LIBNAME).a
LIBSHARED=lib$(LIBNAME).dylib
LIBSHARED_FULL=lib$(LIBNAME).$(DYLIB_MAJ).$(DYLIB_MID).$(DYLIB_MIN).dylib
LIBSHARED_MAJ=lib$(LIBNAME).$(DYLIB_MAJ).dylib
LIB_INSTALLNAME=$(LIBSHARED_MAJ)
PLAYER=wildmidi
PLAYER_STATIC=wildmidi-static

INCLUDE=-I. -I../include
ARFLAGS=cr
CFLAGS=$(INCLUDE) -Wall -W -fno-common
LDFLAGS=
LDLIBS=
ifeq ($(DEBUG),1)
CFLAGS+=-g
else
CFLAGS+=-O2 -fomit-frame-pointer -ffast-math
endif
# specifically for 10.5 and newer:
#CFLAGS+=-mmacosx-version-min=10.5
#LDFLAGS+=-mmacosx-version-min=10.5
#
# specifically for 10.6 and newer:
# old gcc-based cross-toolchains need -Wl,-lbundle1.o
#CFLAGS+=-mmacosx-version-min=10.6
#LDFLAGS+=-mmacosx-version-min=10.6 -Wl,-lbundle1.o

CFLAGS_LIB=$(CFLAGS) -DWILDMIDI_BUILD
LDFLAGS_LIB=$(LDFLAGS)
LDLIBS_LIB=$(LDLIBS)
LDFLAGS_LIB+=-dynamiclib -Wl,-single_module
LDFLAGS_LIB+=-Wl,-undefined,error
LDFLAGS_LIB+=-Wl,-install_name,"@executable_path/$(LIB_INSTALLNAME)"
LDFLAGS_LIB+=-Wl,-compatibility_version,$(DYLIB_MAJ).0.0 -Wl,-current_version,$(DYLIB_MAJ).$(DYLIB_MID).$(DYLIB_MIN)

CFLAGS_EXE=$(CFLAGS)
LDFLAGS_EXE=$(LDFLAGS)
LDLIBS_EXE=$(LDLIBS)
# for CoreAudio
LDFLAGS_EXE+=-Wl,-framework,AudioToolbox -Wl,-framework,AudioUnit -Wl,-framework,CoreServices
LDLIBS_EXE+=-L. -l$(LIBNAME)

# Objects
LIB_OBJ = wm_error.o file_io.o lock.o wildmidi_lib.o reverb.o gus_pat.o
LIB_OBJ+= f_xmidi.o f_mus.o f_hmp.o f_midi.o f_hmi.o mus2mid.o xmi2mid.o internal_midi.o patches.o sample.o
PLAYER_OBJ = wm_tty.o msleep.o out_none.o out_wave.o out_coreaudio.o wildmidi.o
# out_openal.o

.PHONY: clean distclean

help:
	@echo "Valid targets:"
	@echo ""
	@echo "  $(MAKE) shared"
	@echo "  $(MAKE) static"
	@echo ""

shared: $(LIBSHARED) $(PLAYER)
shared: CFLAGS_LIB+=-fvisibility=hidden -DSYM_VISIBILITY

static: $(LIBSTATIC) $(PLAYER_STATIC)
static: CFLAGS+=-DWILDMIDI_STATIC

$(LIBSHARED_FULL): $(LIB_OBJ)
	$(CC) $^ $(LDFLAGS_LIB) $(LDLIBS_LIB) -o $@
$(LIBSHARED_MAJ): $(LIBSHARED_FULL)
	ln -s $^ $@
$(LIBSHARED): $(LIBSHARED_MAJ)
	ln -s $^ $@

$(LIBSTATIC): $(LIB_OBJ)
	$(AR) $(ARFLAGS) $@ $^
	$(RANLIB) $@

$(PLAYER): $(PLAYER_OBJ) $(LIBSHARED)
	$(LD) $(PLAYER_OBJ) $(LDFLAGS_EXE) $(LDLIBS_EXE) -o $@

$(PLAYER_STATIC): $(PLAYER_OBJ) $(LIBSTATIC)
	$(LD) $(PLAYER_OBJ) $(LDFLAGS_EXE) $(LDLIBS_EXE) -o $@

# Build rules
%.o: %.c
	$(CC) -c $(CFLAGS_LIB) -o $@ $<
%.o: ../src/%.c
	$(CC) -c $(CFLAGS_LIB) -o $@ $<
# for player objects:
wildmidi.o: ../src/player/wildmidi.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
out_none.o: ../src/player/out_none.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
out_wave.o: ../src/player/out_wave.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
out_coreaudio.o: ../src/player/out_coreaudio.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
out_openal.o: ../src/player/out_openal.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
msleep.o: ../src/player/msleep.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
wm_tty.o: ../src/player/wm_tty.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<

clean:
	rm -rf $(LIB_OBJ) $(PLAYER_OBJ)

distclean: clean
	rm -rf *.a *.dylib $(PLAYER) $(PLAYER_STATIC)

=== mingw/Makefile ===
# Makefile to build WildMidi library and player for Windows using MinGW / MinGW-w64.

# Set to 1 for debug build
DEBUG = 0

# The tools
ifeq ($(CROSS),)
CC=gcc
AS=as
AR=ar
RANLIB=ranlib
else
CC=$(CROSS)-gcc
AS=$(CROSS)-as
AR=$(CROSS)-ar
RANLIB=$(CROSS)-ranlib
endif
LD = $(CC)

LIBNAME=WildMidi
LIBSTATIC=lib$(LIBNAME).a
LIBSHARED=lib$(LIBNAME).dll
DEFNAME=lib$(LIBNAME).def
IMPLIB=lib$(LIBNAME).dll.a
PLAYER=wildmidi.exe
PLAYER_STATIC=wildmidi-static.exe

INCLUDE=-I. -I../include
ARFLAGS=cr
CFLAGS=$(INCLUDE) -Wall -W -fno-common
LDFLAGS=
LDLIBS=
ifeq ($(DEBUG),1)
CFLAGS+=-g
else
CFLAGS+=-O2 -fomit-frame-pointer -ffast-math
endif

CFLAGS_LIB=$(CFLAGS) -DWILDMIDI_BUILD
LDFLAGS_LIB=$(LDFLAGS) -shared -mconsole
LDLIBS_LIB=$(LDLIBS)
LDFLAGS_LIB+=-Wl,--enable-auto-image-base -Wl,--no-undefined \
		-Xlinker --output-def -Xlinker $(DEFNAME) \
		-Xlinker --out-implib -Xlinker $(IMPLIB)

CFLAGS_EXE=$(CFLAGS)
LDFLAGS_EXE=$(LDFLAGS) -mconsole
LDLIBS_EXE=$(LDLIBS)
# for WinMM output
LDLIBS_EXE+=-lwinmm
LDLIBS_EXE+=-L. -l$(LIBNAME)

# Objects
LIB_OBJ = wm_error.o file_io.o lock.o wildmidi_lib.o reverb.o gus_pat.o
LIB_OBJ+= f_xmidi.o f_mus.o f_hmp.o f_midi.o f_hmi.o mus2mid.o xmi2mid.o internal_midi.o patches.o sample.o
PLAYER_OBJ = wm_tty.o msleep.o getopt_long.o out_none.o out_wave.o out_win32mm.o wildmidi.o
# out_openal.o

.PHONY: clean distclean

help:
	@echo "Valid targets:"
	@echo ""
	@echo "  $(MAKE) shared"
	@echo "  $(MAKE) static"
	@echo ""

shared: $(LIBSHARED) $(PLAYER)
shared: CFLAGS_LIB+=-DDLL_EXPORT

static: $(LIBSTATIC) $(PLAYER_STATIC)
static: CFLAGS+=-DWILDMIDI_STATIC

$(LIBSHARED): $(LIB_OBJ)
	$(CC) $^ $(LDFLAGS_LIB) $(LDLIBS_LIB) -o $@

$(LIBSTATIC): $(LIB_OBJ)
	$(AR) $(ARFLAGS) $@ $^
	$(RANLIB) $@

$(PLAYER): $(PLAYER_OBJ) $(LIBSHARED)
	$(LD) $(PLAYER_OBJ) $(LDFLAGS_EXE) $(LDLIBS_EXE) -o $@

$(PLAYER_STATIC): $(PLAYER_OBJ) $(LIBSTATIC)
	$(LD) $(PLAYER_OBJ) $(LDFLAGS_EXE) $(LDLIBS_EXE) -o $@

# Build rules
%.o: %.c
	$(CC) -c $(CFLAGS_LIB) -o $@ $<
%.o: ../src/%.c
	$(CC) -c $(CFLAGS_LIB) -o $@ $<
# for player objects:
wildmidi.o: ../src/player/wildmidi.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
out_none.o: ../src/player/out_none.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
out_wave.o: ../src/player/out_wave.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
out_win32mm.o: ../src/player/out_win32mm.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
out_openal.o: ../src/player/out_openal.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
msleep.o: ../src/player/msleep.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
wm_tty.o: ../src/player/wm_tty.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<
getopt_long.o: ../src/getopt_long.c
	$(CC) -c $(CFLAGS_EXE) -o $@ $<

clean:
	rm -rf $(LIB_OBJ) $(PLAYER_OBJ)

distclean: clean
	rm -rf *.a *.dll *.def *.exe

=== src/CMakeLists.txt ===
# Setup our wildmidi library that we link to
SET(wildmidi_library_SRCS
    wm_error.c
    file_io.c
    lock.c
    wildmidi_lib.c
    reverb.c
    gus_pat.c
    internal_midi.c
    patches.c
    f_xmidi.c
    f_mus.c
    f_hmp.c
    f_midi.c
    f_hmi.c
    sample.c
    mus2mid.c
    xmi2mid.c
)

SET(wildmidi_library_HDRS
 ../include/wm_error.h
 ../include/file_io.h
 ../include/lock.h
 ../include/wildmidi_lib.h
 ../include/reverb.h
 ../include/gus_pat.h
 ../include/f_xmidi.h
 ../include/f_mus.h
 ../include/f_hmp.h
 ../include/f_midi.h
 ../include/f_hmi.h
 ../include/internal_midi.h
 ../include/patches.h
 ../include/sample.h
 ../include/common.h
 ../include/filenames.h
 ../include/mus2mid.h
 ../include/xmi2mid.h
 ../include/wm_tty.h
 ../include/wildplay.h
)

# set our library names
IF (MSVC) # windows uses *.lib for both static and dynamic, workaround
    SET(LIBRARY_DYN_NAME "libWildMidi")
    SET(LIBRARY_STATIC_NAME "libWildMidi-static")
ELSE () # everyone else uses .a and .so
    SET(LIBRARY_DYN_NAME "WildMidi")
    SET(LIBRARY_STATIC_NAME "WildMidi")
ENDIF()

ADD_LIBRARY(libwildmidi-static STATIC
    ${wildmidi_library_SRCS}
    ${wildmidi_library_HDRS}
)

SET_TARGET_PROPERTIES(libwildmidi-static PROPERTIES
    OUTPUT_NAME ${LIBRARY_STATIC_NAME} CLEAN_DIRECT_OUTPUT 1
    COMPILE_DEFINITIONS WILDMIDI_BUILD
)
TARGET_COMPILE_DEFINITIONS(libwildmidi-static INTERFACE
    WILDMIDI_STATIC
)
TARGET_INCLUDE_DIRECTORIES(libwildmidi-static INTERFACE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

# If the static library was not requested, we do not add it to the "all" & "install" targets
IF (WANT_STATIC)
    LIST(APPEND wildmidi_lib_install libwildmidi-static)
ELSE ()
    SET_TARGET_PROPERTIES(libwildmidi-static PROPERTIES EXCLUDE_FROM_ALL ON)
ENDIF()

IF (BUILD_SHARED_LIBS)
    # dynamic library
    ADD_LIBRARY(libwildmidi SHARED
        ${wildmidi_library_SRCS}
        ${wildmidi_library_HDRS}
    )
    TARGET_LINK_LIBRARIES(libwildmidi
        ${EXTRA_LDFLAGS}
        ${M_LIBRARY}
    )
    SET_TARGET_PROPERTIES(libwildmidi PROPERTIES
        SOVERSION ${SOVERSION}
        VERSION ${VERSION}
        OUTPUT_NAME ${LIBRARY_DYN_NAME} CLEAN_DIRECT_OUTPUT 1
    )

    IF (WIN32)
        SET_TARGET_PROPERTIES(libwildmidi PROPERTIES
            DEFINE_SYMBOL DLL_EXPORT
            COMPILE_DEFINITIONS WILDMIDI_BUILD
        )
    ELSEIF (HAVE_VISIBILITY_HIDDEN AND HAVE_VISIBILITY_DEFAULT) # GCC, Clang
        SET_TARGET_PROPERTIES(libwildmidi PROPERTIES
            COMPILE_DEFINITIONS "WILDMIDI_BUILD;SYM_VISIBILITY"
            COMPILE_FLAGS "-fvisibility=hidden"
        )
    #ELSEIF (HAVE_LDSCOPE_HIDDEN AND HAVE_VISIBILITY_DEFAULT) # SunPro (__SUNPRO_C >= 0x590)
    #   SET_TARGET_PROPERTIES(libwildmidi PROPERTIES
    #       COMPILE_DEFINITIONS "WILDMIDI_BUILD;SYM_VISIBILITY"
    #       COMPILE_FLAGS "-xldscope=hidden"
    #   )
    ELSEIF (HAVE_LDSCOPE_HIDDEN AND HAVE_LDSCOPE_GLOBAL) # SunPro (__SUNPRO_C >= 0x550)
        SET_TARGET_PROPERTIES(libwildmidi PROPERTIES
            COMPILE_DEFINITIONS "WILDMIDI_BUILD;SYM_LDSCOPE"
            COMPILE_FLAGS "-xldscope=hidden"
        )
    ELSE ()
        SET_TARGET_PROPERTIES(libwildmidi PROPERTIES
            COMPILE_DEFINITIONS WILDMIDI_BUILD
        )
    ENDIF()
    LIST(APPEND wildmidi_lib_install libwildmidi)
ENDIF()

IF (WANT_DEVTEST)
    SET(wildmidi-devtest_executable_SRCS
        DevTest.c
    )
    IF (MSVC)
        LIST(APPEND wildmidi-devtest_executable_SRCS getopt_long.c)
    ENDIF()
    ADD_EXECUTABLE(wildmidi-devtest
        ${wildmidi-devtest_executable_SRCS}
    )
    LIST(APPEND wildmidi_install wildmidi-devtest)
ENDIF()

# prepare pkg-config file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
CONFIGURE_FILE("wildmidi.pc.in" "${PROJECT_BINARY_DIR}/wildmidi.pc" @ONLY)

INSTALL(TARGETS ${wildmidi_lib_install}
    EXPORT WildMidi-export
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)
INSTALL(TARGETS ${wildmidi_install}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

INSTALL(FILES ${PROJECT_BINARY_DIR}/wildmidi.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
INSTALL(FILES ${PROJECT_SOURCE_DIR}/include/wildmidi_lib.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/docs/man/ DESTINATION ${CMAKE_INSTALL_MANDIR})
INSTALL(EXPORT WildMidi-export FILE WildMidiTargets.cmake
    NAMESPACE WildMidi:: DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/WildMidi
)

INCLUDE(CMakePackageConfigHelpers)
CONFIGURE_PACKAGE_CONFIG_FILE(
    "${PROJECT_SOURCE_DIR}/src/WildMidiConfig.cmake.in"
    "${PROJECT_BINARY_DIR}/WildMidiConfig.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/WildMidi"
    NO_SET_AND_CHECK_MACRO
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
)

WRITE_BASIC_PACKAGE_VERSION_FILE(
    "${PROJECT_BINARY_DIR}/WildMidiConfigVersion.cmake"
    COMPATIBILITY AnyNewerVersion
)

INSTALL(FILES
    "${PROJECT_BINARY_DIR}/WildMidiConfig.cmake"
    "${PROJECT_BINARY_DIR}/WildMidiConfigVersion.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/WildMidi"
)

IF (WIN32 AND MSVC)
    IF (WANT_MP_BUILD)
        SET(MT_BUILD "/MP")
    ENDIF()
ENDIF()

IF (WANT_PLAYER OR WANT_PLAYERSTATIC)
    ADD_SUBDIRECTORY(player)
ENDIF()

=== src/player/CMakeLists.txt ===
# WildMidi Player related stuff

SET(wildmidi_executable_SRCS
    amiga.c
    msleep.c
    out_none.c
    out_ahi.c
    out_alsa.c
    out_coreaudio.c
    out_dart.c
    dos/dosdma.c
    dos/dosirq.c
    dos/dossb.c
    out_dossb.c
    out_netbsd.c
    out_openal.c
    out_oss.c
    out_sndio.c
    out_wave.c
    out_win32mm.c
    wm_tty.c
    wildmidi.c
)

IF (MSVC)
    LIST(APPEND wildmidi_executable_SRCS ../getopt_long.c)
ENDIF()

# do we want the wildmidi player?
IF (WANT_PLAYER)
    ADD_EXECUTABLE(wildmidi	${wildmidi_executable_SRCS})
    IF (AUDIODRV_OPENAL)
        TARGET_INCLUDE_DIRECTORIES(wildmidi PRIVATE ${OPENAL_INCLUDE_DIR})
    ENDIF()
    IF (AUDIODRV_ALSA)
        TARGET_INCLUDE_DIRECTORIES(wildmidi PRIVATE ${ALSA_INCLUDE_DIR})
    ENDIF()
    IF (AUDIODRV_SNDIO)
        TARGET_INCLUDE_DIRECTORIES(wildmidi PRIVATE ${SNDIO_INCLUDE_DIR})
    ENDIF()

    TARGET_LINK_LIBRARIES(wildmidi
        ${EXTRA_LDFLAGS}
        libwildmidi
        ${AUDIO_LIBRARY}
        ${M_LIBRARY}
    )
    LIST(APPEND wildmidi_install wildmidi)
ENDIF()

IF (WANT_PLAYERSTATIC)
    ADD_EXECUTABLE(wildmidi-static ${wildmidi_executable_SRCS})
    SET_TARGET_PROPERTIES(wildmidi-static PROPERTIES COMPILE_DEFINITIONS WILDMIDI_STATIC)

    IF (AUDIODRV_OPENAL)
        TARGET_INCLUDE_DIRECTORIES(wildmidi-static PRIVATE ${OPENAL_INCLUDE_DIR})
    ENDIF()
    IF (AUDIODRV_ALSA)
        TARGET_INCLUDE_DIRECTORIES(wildmidi-static PRIVATE ${ALSA_INCLUDE_DIR})
    ENDIF()
    IF (AUDIODRV_SNDIO)
        TARGET_INCLUDE_DIRECTORIES(wildmidi-static PRIVATE ${SNDIO_INCLUDE_DIR})
    ENDIF()

    TARGET_LINK_LIBRARIES(wildmidi-static
        ${EXTRA_LDFLAGS}
        libwildmidi-static
        ${AUDIO_LIBRARY}
        ${M_LIBRARY}
    )
    LIST(APPEND wildmidi_install wildmidi-static)

    IF (RISCOS)
        SET_TARGET_PROPERTIES(wildmidi-static PROPERTIES LINK_FLAGS "-static")
        ADD_CUSTOM_COMMAND(OUTPUT ${PROJECT_BINARY_DIR}/wildmidi,ff8
            COMMAND elf2aif ${PROJECT_BINARY_DIR}/wildmidi-static ${PROJECT_BINARY_DIR}/wildmidi,ff8
            DEPENDS wildmidi-static)
        ADD_CUSTOM_TARGET(wildmidi-aif ALL DEPENDS ${PROJECT_BINARY_DIR}/wildmidi,ff8)
    ENDIF()
ENDIF()

INSTALL(TARGETS ${wildmidi_install}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

IF (WIN32 AND MSVC)
    SET(WARNINGS "/W3")
    IF (WANT_PLAYER)
        SET_TARGET_PROPERTIES(wildmidi PROPERTIES COMPILE_FLAGS "${WARNINGS} ${MT_BUILD}")
        # Release builds use the debug console
        SET_TARGET_PROPERTIES(wildmidi PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:CONSOLE")
        SET_TARGET_PROPERTIES(wildmidi PROPERTIES LINK_FLAGS_MINSIZEREL "/SUBSYSTEM:CONSOLE")
        TARGET_COMPILE_DEFINITIONS(wildmidi PRIVATE $<$<CONFIG:Release>:_CONSOLE>)
        TARGET_COMPILE_DEFINITIONS(wildmidi PRIVATE $<$<CONFIG:MinSizeRel>:_CONSOLE>)
    ENDIF()
    IF (WANT_PLAYERSTATIC)
        SET_TARGET_PROPERTIES(wildmidi-static PROPERTIES COMPILE_FLAGS "${WARNINGS} ${MT_BUILD}")
        # Release builds use the debug console
        SET_TARGET_PROPERTIES(wildmidi-static PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:CONSOLE")
        SET_TARGET_PROPERTIES(wildmidi-static PROPERTIES LINK_FLAGS_MINSIZEREL "/SUBSYSTEM:CONSOLE")
        TARGET_COMPILE_DEFINITIONS(wildmidi-static PRIVATE $<$<CONFIG:Release>:_CONSOLE>)
        TARGET_COMPILE_DEFINITIONS(wildmidi-static PRIVATE $<$<CONFIG:MinSizeRel>:_CONSOLE>)
    ENDIF()
ENDIF()

=== debian/changelog ===
wildmidi (0.4.6-1) unstable; urgency=medium

  * Team Upload

  [ Bret Curtis ]
  * New upstream release.
  * Update control and metadata (Closes: #1082522)
  * Added cmake and .pc files (Closes: #916631)
  * Added hardening and build-depends-package from lintian

  [ Patrice Duroux ]
  * Updated watchfile (Closes: #1036913)

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.5.0, no changes needed.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Use secure URI in Homepage field.
  * Update watch file format version to 4.
  * Apply multi-arch hints.
    + libwildmidi-dev: Add Multi-Arch: same.

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Aug 2025 18:09:51 +0200

=== debian/control ===
Source: wildmidi
Section: sound
Priority: optional
Maintainer: Bret Curtis <psi29a@gmail.com>
Uploaders:
 Emmet Hikory <emmet.hikory@gmail.com>,
 Sebastian Dröge <slomo@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libasound2-dev [linux-any],
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/Mindwerks/wildmidi
Vcs-Browser: https://salsa.debian.org/games-team/WildMIDI
Vcs-Git: https://salsa.debian.org/games-team/WildMIDI.git
X-Style: black

Package: wildmidi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libwildmidi-config,
Description: software MIDI player
 Minimal MIDI player implementation based on the wildmidi library that
 can either dump to WAV or playback over ALSA. It is intended to
 demonstrate the features of libWildMidi, including: reberb, logarithmic
 volume and high-quality linear or gauss resampling.

Package: libwildmidi2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libwildmidi-config,
Replaces:
 libwildmidi0,
Description: software MIDI player library
 MIDI streaming library designed to process a MIDI file using sound patches
 and stream the results as stereo audio data through a buffer which an
 external program can then process further.

Package: libwildmidi-dev
Section: libdevel
Architecture: any
Depends:
 libwildmidi2 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 libwildmidi-config,
Multi-Arch: same
Description: software MIDI player library headers
 MIDI streaming library designed to process a MIDI file using sound patches
 and stream the results as stereo audio data through a buffer which an
 external program can then process further.
 .
 This package contains the development headers, static library and symlinks
 to libWildMidi.so.1

Package: libwildmidi-config
Section: misc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 freepats,
Description: software MIDI player configuration
 MIDI streaming library designed to process a MIDI file using sound patches
 and stream the results as stereo audio data through a buffer which an
 external program can then process further.
 .
 This package contains the configuration files and relevant documentation

=== debian/rules ===
#! /usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Uncomment to view all compilation commands and fix W-compiler-flags-hidden
export VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#CMake silently ignores CPPFLAGS. Below will properly set CFLAGS/CXXFLAGS
#https://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DWANT_STATIC=YES -DWANT_PLAYERSTATIC=NO -DCMAKE_BUILD_TYPE="Release"

override_dh_installchangelogs:
	dh_installchangelogs README.md

override_dh_clean:
	dh_clean
	-rm -f include/config.h

=== debian/watch ===
version=4
opts="searchmode=plain" \
    https://api.github.com/repos/Mindwerks/@PACKAGE@/releases?per_page=100 \
    https://github.com/Mindwerks/@PACKAGE@/releases/download/[^/]+/@PACKAGE@-(\d[\.\d]*)@ARCHIVE_EXT@
